program tetrahex;

{ UJAs Tetrix mit Hexominos }
{ V.0.90 : 30.08.94  1. spielbare Version, Highscore und Gameover-Routine,  }
{                    einfache Steine ok, Blcke ok, Bonus ok, Bomba ok,     }
{ V.1.00 : 31.08.94  Gift ok, Dreh- und Spiegelregeln erleichtert,          }
{                    +, - fr Levels eingebaut                              }
{ V.1.01 :  1. 9.94  Randeffekt beseitigt, Bonus erhht, Bmbskes werfen    }
{                    eingebaut                                              }
{ V.1.02 :  8. 9.94  Bug bei Bombe rechts/links-Randeffekt beseitigt        }
{ V.1.10 : 10.11.94  variable Speed, bergabe mit CLI-Parameter 1 - 8       }

{ Feld: 0:frei, 1-7:Stein, 8:Mauer, 9:Bonus, 10:Bombe, 11:Gift, 15: Block   }
{ zu den Images: }
{ ima[0] enthlt die Maske, 1-11 entspricht dem Feldinhalt, 12 leere Stelle }
{ Die Images sind im imafile hintereinanderweg abgespeichert, erst die      }
{ Image-Structure, dann die Grafikdaten.                                    }
{ ------------------------------------------------------------------------- }

uses crt,graph,dos,BGIDriv,BGIFont;

const titel='         UJAs TetraHex V.1.10 (mit Bmbskes)  -  11/94 - TP6.0';
      imabuff  =2800;
      imafile  ='thex.ima';
      levelfile='thexlev.';
      hscfile  ='thex.hsc';

      ox=200; oy=32; dx=16; dy=16; dxy=8; xmax=28; ymax=24;
      voll :FillPatternType=($ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff);
      halb :FillPatternType=($55,$aa,$55,$aa,$55,$aa,$55,$aa);

type feld =array[0..xmax,0..ymax] of word;

     image  =record { aus Intuit-TPU }
             x,y         :integer;
             width,height:integer;
             p_data      :pointer;
             p_nextimage :pointer;
          end;
     chipbase=record
             x,y      :integer;
             pattern  :array[0..3,0..3] of word;
             turn,flip:integer;
          end;
     chips=array[0..56] of chipbase;
     hiscore=array[0..11] of record
                namen:string;
                score:longint;
             end;

var ima                           :array[0..12] of image;
    chip                          :chips;
    f                             :feld;
    level,i,j,haengt,timing,delay0:word;
    punkte,chipcount              :longint;
    levelname                     :string;
    cc                            :char;
    ok,over,ende,ri,bombe         :boolean;
    hsc                           :hiscore;

{$i initscree.inc } { BGI-Library, Screen zeichnen     }
{$i initkrams.inc } { Chips generieren, internes Level }
{$i tethxhsc.inc  } { High-Score Routinen }
{$i zeichnen.inc  } { Chips zeichnen, Punkte updaten }

function checklock(chip:chipbase; xx,yy:word):word;
var i,j,k,haengtan:word;
begin
   haengtan:=0;
   with chip do for i:=0 to 3 do for j:=0 to 3 do
      if pattern[i,j]>0 then if f[xx+i,yy+j]>0 then begin
      k:=f[xx+i,yy+j];
      if k in [10,11] then begin
         if haengtan=0 then haengtan:=k;
      end else haengtan:=k;
      { damit man nicht sofort bei einer Bombe hops geht! }
   end;
   checklock:=haengtan;
end;    

procedure dropsaeule(x,y:word);
var j     :word;
    fertig:boolean;
begin
   j:=y;
   fertig:=j<1;
   while not fertig do begin
      dec(j);
      fertig:=(j<1) or (f[x,j] in [8,10,11,15]);  { Stein,Bombe,Gift,Block }
      if not fertig then f[x,succ(j)]:=f[x,j] else f[x,succ(j)]:=0;
      zeichnestein(x,succ(j),f[x,succ(j)]);
   end;
end;

procedure checkreihe(var punkte:longint; var bombe:boolean);
var i,j,bonus   :integer;
    voll,gueltig:boolean;
begin
for j:=ymax downto 1 do begin
   voll:=true;
   while voll do begin
      gueltig:=false;
      bonus:=0;
      for i:=1 to xmax do begin
         if f[i,j]=0 then voll:=false;
         if f[i,j] in [1..7] then gueltig:=true;
         if f[i,j]=9 then inc(bonus);
      end;
      voll:=voll and gueltig;
      if voll then begin
         bombe:=true;
         for i:=1 to xmax do if f[i,j] in [1..7,9,10,11] then dropsaeule(i,j);
         punkte:=punkte+10*(100-timing)+bonus*1000;
      end;
   end;
end;
end;

procedure dropchip(var chip:chipbase; ri:boolean; var haengt:word);
var xx,yy,i,j:integer;
begin
   with chip do begin
      if ri then xx:=x else xx:=succ(x);
      yy:=succ(y);
      haengt:=checklock(chip,xx,yy);
      if haengt>0 then begin
         for i:=0 to 3 do for j:=0 to 3 do if pattern[i,j]>0
         then f[x+i,y+j]:=pattern[i,j];
      end else begin
         loeschechip(0,0,chip);
         y:=yy;
         x:=xx;
         zeichnechip(0,0,chip);
      end;
   end;
end;


procedure initchip(var over:boolean; bombe:boolean);
begin
   if bombe then with chip[0] do begin
      for i:=0 to 3 do for j:=0 to 3 do pattern[i,j]:=0;
      pattern[0,0]:=10;
      turn:=0;
      flip:=0;
   end else chip[0]:=chip[succ(random(56))];
   chip[0].x:=1;
   chip[0].y:=1;
   zeichnechip(0,0,chip[0]);
   over:=(not bombe) and (checklock(chip[0],chip[0].x,chip[0].y)>0);
end;

procedure gameover(var cc:char);
var i,j,k:word;
    t    :string;
begin
   for i:=0 to 15 do setpalette(i,0);
   setpalette(1,8);
   setpalette(3,7);
   SetTextStyle(gothicfont,horizdir,4);
   t:='G a m e  o v e r !';
   setcolor(0);
   for i:=103 to 107 do for j:=239 to 243 do outtextxy(i,j,t);
   setcolor(3);
   for i:=102 to 106 do for j:=238 to 242 do outtextxy(i,j,t);
   setcolor(1);
   outtextxy(104,240,t);
   cc:=readkey;
   SetTextStyle(Defaultfont,horizdir,1); 
   for i:=0 to 15 do setpalette(i,i);
end;

procedure drehen;  { alles common }
var xx:integer;
begin
   with chip[0] do begin
      xx:=x;
      haengt:=checklock(chip[turn],xx,y);
      if haengt>0 then begin { Chip nach rechts }
         xx:=succ(x);
         haengt:=checklock(chip[turn],xx,y);
         if haengt>0 then begin  { Chip nach links }
            xx:=pred(x);
            haengt:=checklock(chip[turn],xx,y);
         end;
      end;
      if haengt=0 then begin
         chip[turn].x:=xx;
         chip[turn].y:=y;
         loeschechip(0,0,chip[0]);
         chip[0]:=chip[turn];
         zeichnechip(0,0,chip[0]);
      end else haengt:=0;
   end;
end;

procedure spiegeln;  { alles common }
var xx:integer;
begin
   with chip[0] do begin
      xx:=x;
      haengt:=checklock(chip[flip],xx,y);
      if haengt>0 then begin { Chip nach rechts }
         xx:=succ(x);
         haengt:=checklock(chip[flip],xx,y);
         if haengt>0 then begin  { Chip nach links }
            xx:=pred(x);
            haengt:=checklock(chip[flip],xx,y);
         end;
      end;
      if haengt=0 then begin
         chip[flip].x:=xx;
         chip[flip].y:=y;
         loeschechip(0,0,chip[0]);
         chip[0]:=chip[flip];
         zeichnechip(0,0,chip[0]);
      end else haengt:=0;
   end;
   ri:=not ri;
end;

procedure links;
begin
with chip[0] do begin
   if x>1 then begin
      dec(x);
      haengt:=checklock(chip[0],x,y);
      inc(x);
   end else haengt:=15;
   if haengt=0 then begin
      loeschechip(0,0,chip[0]);
      dec(x);
      zeichnechip(0,0,chip[0]);
   end else haengt:=0;
end;
end;

procedure rechts;
begin
with chip[0] do begin
   if x<xmax then begin
      inc(x);
      haengt:=checklock(chip[0],x,y);
      dec(x);
   end else haengt:=15;
   if haengt=0 then begin
      loeschechip(0,0,chip[0]);
      inc(x);
      zeichnechip(0,0,chip[0]);
   end else haengt:=0;
end;
end;

procedure dropbombe(var chip:chipbase; ri:boolean; var haengt:word);
var xx,yy,i,j:integer;
begin
   with chip do begin
      if ri then xx:=x else xx:=succ(x);
      yy:=succ(y);
      haengt:=checklock(chip,xx,yy);
      loeschechip(0,0,chip);
      if haengt>0 then begin
         for i:=0 to 3 do for j:=0 to 3 do if pattern[i,j]>0
         then if f[xx+i,yy+j] in [1..7,9..11] then begin
            f[xx+i,yy+j]:=0;
            zeichnestein(xx+i,yy+j,0);
         end;
         sound(1000);
         delay(10);
         nosound;
      end else begin
         y:=yy;
         x:=xx;
         zeichnechip(0,0,chip);
      end;
   end;
end;

procedure bomberechts;
var i,j:integer;
begin
with chip[0] do begin
   if x<xmax then haengt:=checklock(chip[0],succ(x),y) else haengt:=15;
   loeschechip(0,0,chip[0]);
   inc(x);
   if haengt=0 then zeichnechip(0,0,chip[0])
   else begin  { Steine, Bonus, Bmbchen und Gift abschieen }
      for i:=0 to 3 do for j:=0 to 3 do if pattern[i,j]>0
      then if f[x+i,y+j] in [1..7,9..11] then begin
         f[x+i,y+j]:=0;
         zeichnestein(x+i,y+j,0);
      end;
      sound(1000);
      delay(10);
      nosound;
      dec(x);
   end;
end;
end;


procedure bombelinks;
var i,j:integer;
begin
with chip[0] do begin
   if x>1 then haengt:=checklock(chip[0],pred(x),y) else haengt:=15;
   loeschechip(0,0,chip[0]);
   dec(x);
   if haengt=0 then zeichnechip(0,0,chip[0])
   else begin  { Steine, Bonus, Bmbchen und Gift abschieen }
      for i:=0 to 3 do for j:=0 to 3 do if pattern[i,j]>0
      then if f[x+i,y+j] in [1..7,9..11] then begin
         f[x+i,y+j]:=0;
         zeichnestein(x+i,y+j,0);
      end;
      sound(1000);
      delay(10);
      nosound;
      inc(x);
   end;
end;
end;


procedure startgame;   { setzt Startwerte fr einen Durchgang }
begin
   initlevel(level,levelname,f);
   timing:=delay0;
   ende:=false;
   ri:=true;
   zeichnefeld(level,levelname,f);
   updatpunkte(punkte);
   bombe:=false;
   initchip(over,false);
   haengt:=0;
   chipcount:=0;
end;

{ ===== Main Prog ===== }

begin
   delay0:=10;
   if paramcount>0 then begin
      val(paramstr(1),delay0,i);
      if not (delay0 in [1..99]) then delay0:=10;
   end;
   initscreen(ok);
   initchips(chip);
   zeichnescreen;
   loadhiscore(hsc);
   showhiscore(hsc);
   level:=1;
   punkte:=0;
   randomize;


   startgame;
   bombe:=false;
   while not ende do begin        { Main Loop }

      { 20 x Keyboardcheck, 1x Drop }
      { ------------------------------------------------------- }
      i:=0;
      while (i<19) and (not ende) do begin
         inc(i);
         delay(timing*10);
         while keypressed do begin
           cc:=readkey;
           if cc=#0 then begin  { Control-Keys }
               cc:=readkey;
               case cc of
               #72: drehen; { Cursor up }
               #75: if bombe then bombelinks else links;
               #77: if bombe then bomberechts else rechts;
               #80: repeat                    { down }
                       if bombe then dropbombe(chip[0],ri,haengt)
                                else dropchip(chip[0],ri,haengt)
                    until haengt>0;
               end; { case }
            end { cc-keys } else case cc of
               #27: ende:=true;
           'F','f': spiegeln;
           'P','p': begin
                       while keypressed do cc:=readkey;  { Keyb. abrumen }
                       cc:=readkey;                      { ... und weiter }
                    end;
           'T','t': drehen;
           '+'    : begin
                       inc(level);
                       startgame;
                    end;
           '-'    : begin
                       if level>0 then dec(level);
                       startgame;
                    end;
                 end; { case }

         end; { while keypressed }
      end; { i-loop }

   { ------------------------------------------------------- }
      if haengt=0 then
      if bombe then dropbombe(chip[0],ri,haengt)
               else dropchip(chip[0],ri,haengt);
      sound(100);
      delay(1);
      nosound;
      delay(timing);
      if haengt>0 then begin
         if bombe then begin
            bombe:=not bombe;
            zeichnestein(36,24,0);
         end else case haengt of
            1..9: begin
                  punkte:=punkte+10;
                  checkreihe(punkte,bombe);
                  if bombe then zeichnestein(36,24,10);
                  updatpunkte(punkte);
                  sound(100);
                  delay(10);
                  nosound;
                  end;
            10:   begin  { Bomba la bomba!  }
                     for i:=1 to 20 do begin
                        sound(150-5*i);
                        delay(15);
                        nosound;
                     end;
                     nosound;
                     loeschechip(0,0,chip[0]);
                     with chip[0] do begin 
                        for i:=0 to 3 do for j:=0 to 3 do
                        if pattern[i,j]>0 then f[x+i,y+j]:=0;
                     end;
                  end;

            11:   begin                         { ... und tschss! }
                     for i:=1 to 20 do begin
                        sound(150-5*i);
                        delay(15);
                        nosound;
                     end;
                     loeschechip(0,0,chip[0]);
                     over:=true;
                  end;
             end; { Case }

         if not over then begin
            inc(chipcount);
            if chipcount>40 then begin
               inc(level);
               startgame;
            end else begin
               initchip(over,bombe);
               haengt:=0;
            end;
         end;
         if over then begin
            delay(100);
            while keypressed do cc:=readkey; { KBD-Puffer leeren }
            gameover(cc);
            ende:=ende or (cc=#27);
            if not ende then begin
               updathiscore(hsc,punkte);
               punkte:=0;
               startgame;
            end;
         end else begin
            if timing>10 then dec(timing);    { ich bin so brutal! }
            ri:=not ri;
         end;
      end; { drop-Teil }
   { ------------------------------------------------------- }

   end;  { Main Loop }

   closegraph;
   textmode(3);
end.


